diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalDefinition.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalDefinition.cs
index 010ba73..75c3e04 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalDefinition.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalDefinition.cs
@@ -16,28 +16,40 @@ namespace Leuze.Modules.Goal.Domain.Domains
 
         }
 
-        public GoalDefinition(DomainUser owner, DomainUser creator, string name, DateTime from, DateTime to)
+        public GoalDefinition(DomainUser owner, DomainUser creator, GlobalDefinitionArea gdArea, string name) : this(owner, creator, gdArea, name, 0)
+        {           
+        }
+
+        public GoalDefinition(DomainUser owner, DomainUser creator, GlobalDefinitionArea gdArea, string name, double financeBase)
         {
             this.Owner = owner;
             this.OwnerId = owner.UserId;
             this.Creator = creator;
             this.CreatorId = creator.UserId;
+            this.GDArea = gdArea;
             this.Name = name;
-            this.From = from;
-            this.To = to;
+            this.FinanceBase = financeBase;
+        }
+
+        public static GoalDefinition Default()
+        {
+            return new GoalDefinition();
         }
 
         public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
         public DomainUser Owner { get; private set; }
         public Guid OwnerId { get; private set; }
         public DomainUser Creator { get; private set; }
         public Guid CreatorId { get; private set; }
+        public Guid GDAreaId { get; private set; }
+        public GlobalDefinitionArea GDArea { get; private set; }
         public string Name { get; private set; }
-        public DateTime From { get; private set; }
-        public DateTime To { get; private set; }
         public bool OwnerLocked { get; private set; }
         public bool SupervisorLocked { get; private set; }
-        public decimal? Vari { get; private set; }
+        public double? VariProjectHours { get; private set; }
+        public double FinanceBase { get; private set; }
+
 
         private List<GoalItem> _goals = new List<GoalItem>();
         public IReadOnlyList<GoalItem> Goals => _goals.AsReadOnly();
@@ -46,18 +58,30 @@ namespace Leuze.Modules.Goal.Domain.Domains
         {
             this.Name = name;
         }
-        public void SetFrom(DateTime from)
+        public void SetVariProjectHours(double vari)
         {
-            this.From = from;
+            this.VariProjectHours = vari;
         }
-        public void SetTo(DateTime to)
+
+        public void SetFinanceBase(double vari)
         {
-            this.To = to;
+            this.FinanceBase = vari;
         }
-        public void SetVari(decimal vari)
+
+        public void LockByOwner()
+        {
+            this.OwnerLocked = true;
+        }
+
+        public void LockBySupervisor()
         {
-            this.Vari = vari;
+            this.SupervisorLocked = true;
         }
 
+        public void ResetLocks()
+        {
+            this.OwnerLocked = false;
+            this.SupervisorLocked = false;
+        }
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalItem.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalItem.cs
index 8d2c985..ba0d780 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalItem.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalItem.cs
@@ -32,14 +32,17 @@ namespace Leuze.Modules.Goal.Domain.Domains
         }
 
         public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
         public GoalDefinition GoalDefinition { get; private set; }
         public Guid GoalDefinitionId { get; private set; }
         public DomainUser Creator { get; private set; }
         public Guid CreatorId { get; private set; }
         public string Name { get; private set; }
         public string Description { get; private set; }
-        public decimal PercentileUser { get; private set; }
-        public decimal PercentileFinal { get; private set; }
+        public double PercentileUser { get; private set; }
+        public double PercentileFinal { get; private set; }
+        public bool OwnerLocked { get; private set; }
+        public bool SupervisorLocked { get; private set; }
 
         private List<Comment> _comments = new();
         public IReadOnlyList<Comment> Comments => _comments.AsReadOnly();
@@ -58,14 +61,29 @@ namespace Leuze.Modules.Goal.Domain.Domains
         {
             this.Description = desc;
         }
-        public void SetPercentileUser(decimal perc)
+        public void SetPercentileUser(double perc)
         {
             this.PercentileUser = perc;
         }
-        public void SetPercentileFinal(decimal perc)
+        public void SetPercentileFinal(double perc)
         {
             this.PercentileFinal = perc;
         }
 
+        public void LockByOwner()
+        {
+            this.OwnerLocked = true;
+        }
+
+        public void LockBySupervisor()
+        {
+            this.SupervisorLocked = true;
+        }
+
+        public void ResetLocks()
+        {
+            this.OwnerLocked = false;
+            this.SupervisorLocked = false;
+        }
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalUpdate.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalUpdate.cs
index ce94a40..377df05 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalUpdate.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/GoalUpdate.cs
@@ -26,7 +26,13 @@ namespace Leuze.Modules.Goal.Domain.Domains
             this.NewValue = newValue;
         }
 
+        public static GoalUpdate Default()
+        {
+            return new GoalUpdate();
+        }
+
         public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
         public DomainUser Creator { get; private set; }
         public Guid CreatorId { get; private set; }
         public GoalItem Goal { get; private set; }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Review.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Review.cs
index 86b5776..b545b97 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Review.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Domains/Review.cs
@@ -26,7 +26,13 @@ namespace Leuze.Modules.Goal.Domain.Domains
             this.IsFinal = isFinal;
         }
 
+        public static Review Default()
+        {
+            return new Review();
+        }
+
         public Guid Id { get; private set; }
+        public DateTime CreatedAt { get; private set; } = DateTime.Now;
         public DomainUser Creator { get; private set; }
         public Guid CreatorId { get; private set; }
         public GoalItem Goal { get; private set; }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGlobalDefinitionAreaRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGlobalDefinitionAreaRepository.cs
new file mode 100644
index 0000000..8610852
--- /dev/null
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGlobalDefinitionAreaRepository.cs
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Leuze.Modules.Goal.Domain.Repositories
+{
+    public interface IGlobalDefinitionAreaRepository
+    {
+    }
+}
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
index fd33a06..53d00b2 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
@@ -20,11 +20,9 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 
         Task<bool> RemoveAsync(Guid id);
 
-        Task<bool> SetVariAsync(Guid id, decimal vari);
+        Task<bool> SetVariProjectHoursAsync(Guid id, double vari);
 
-        Task<bool> SetFromAsync(Guid id, DateTime from);
-
-        Task<bool> SetToAsync(Guid id, DateTime to);
+        Task<bool> SetFinanceBaseAsync(Guid id, double financeBase);
 
         Task<bool> SetNameAsync(Guid id, string name);
     }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
index b5decb6..410f5f7 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
@@ -25,9 +25,9 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 
         Task<bool> SetDescriptionAsync(Guid id, string description);
 
-        Task<bool> SetPercentileUserAsync(Guid id, decimal percentile);
+        Task<bool> SetPercentileUserAsync(Guid id, double percentile);
 
-        Task<bool> SetPercentileFinalAsync(Guid id, decimal percentile);
+        Task<bool> SetPercentileFinalAsync(Guid id, double percentile);
 
         Task<bool> SetGoalDefinitionAsync(Guid id, Guid definitionId);
 
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/DependencyInjection.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/DependencyInjection.cs
index 913a92c..37f6221 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/DependencyInjection.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/DependencyInjection.cs
@@ -55,8 +55,9 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence
                 var context = serviceScope.ServiceProvider.GetRequiredService<LeuzeDbContext>();
                 var appSettings = serviceScope.ServiceProvider.GetRequiredService<IOptions<AppSettings>>().Value;
 
+                //TODO: This is debug delet this
                 var user = context.Set<DomainUser>().Where(item => item.EmailAddress.Email == "ma@test.cz").FirstOrDefault();
-                GoalDefinition gd = new GoalDefinition(user, user, "Test Goal definition", DateTime.Now, DateTime.Now.AddDays(10));
+                GoalDefinition gd = new GoalDefinition(user, user, new GlobalDefinitionArea(user, DateTime.Now, DateTime.Now.AddDays(10)) ,"Test Goal definition");
                 context.Add(gd);
                 context.SaveChanges();
             }
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/CommentRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/CommentRegistrar.cs
index aca4b31..6b76cec 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/CommentRegistrar.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/CommentRegistrar.cs
@@ -20,6 +20,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
                 etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
                 etb.HasOne(e => e.Goal).WithMany(e => e.Comments).HasForeignKey(e => e.GoalId);
                 etb.Property(e => e.Text).IsRequired();
+                etb.Property(e => e.CreatedAt).IsRequired();
 
                 etb.ToTable("Leuze_Modules_Goal_Domain_Comments");
             });
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GlobalDefinitionAreaRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GlobalDefinitionAreaRegistrar.cs
new file mode 100644
index 0000000..ee5d117
--- /dev/null
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GlobalDefinitionAreaRegistrar.cs
@@ -0,0 +1,31 @@
+﻿using ExtCore.Data.EntityFramework;
+using Leuze.Modules.Goal.Domain.Domains;
+using Microsoft.EntityFrameworkCore;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
+{
+    public class GlobalDefinitionAreaRegistrar : IEntityRegistrar
+    {
+        public void RegisterEntities(ModelBuilder modelbuilder)
+        {
+            modelbuilder.Entity<GlobalDefinitionArea>(etb =>
+            {
+                etb.HasKey(e => e.Id);
+                etb.Property(e => e.Id).ValueGeneratedOnAdd();
+                etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
+                etb.Property(e => e.From).IsRequired();
+                etb.Property(e => e.To).IsRequired();
+                etb.Property(e => e.CreatedAt).IsRequired();
+                etb.Property(e => e.VariCompanySuccess).IsRequired(false);
+
+
+                etb.ToTable("Leuze_Modules_Goal_Domain_GoalDefinitionAreas");
+            });
+        }
+    }
+}
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalDefinitionRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalDefinitionRegistrar.cs
index 7d80f18..81ee056 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalDefinitionRegistrar.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalDefinitionRegistrar.cs
@@ -19,10 +19,11 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
                 etb.Property(e => e.Id).ValueGeneratedOnAdd();
                 etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
                 etb.HasOne(e => e.Owner).WithMany().HasForeignKey(e => e.OwnerId);
+                etb.HasOne(e => e.GDArea).WithMany().HasForeignKey(e => e.GDAreaId);
                 etb.Property(e => e.Name).IsRequired().HasMaxLength(255);
-                etb.Property(e => e.From).IsRequired();
-                etb.Property(e => e.To).IsRequired();
-                etb.Property(e => e.Vari).IsRequired(false);
+                etb.Property(e => e.FinanceBase).IsRequired();
+                etb.Property(e => e.CreatedAt).IsRequired();
+                etb.Property(e => e.VariProjectHours).IsRequired(false);
                 etb.HasMany(e => e.Goals).WithOne(e => e.GoalDefinition).HasForeignKey(e => e.GoalDefinitionId);
 
 
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalRegistrar.cs
index ac771df..050e571 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalRegistrar.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalRegistrar.cs
@@ -20,6 +20,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
                 etb.HasOne(e => e.GoalDefinition).WithMany(e => e.Goals).HasForeignKey(e => e.GoalDefinitionId);
                 etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
                 etb.Property(e => e.Name).IsRequired().HasMaxLength(255);
+                etb.Property(e => e.CreatedAt).IsRequired();
                 etb.HasMany(e => e.Comments).WithOne(e => e.Goal).HasForeignKey(e => e.GoalId);
                 etb.HasMany(e => e.Updates).WithOne(e => e.Goal).HasForeignKey(e => e.GoalId);
                 etb.HasMany(e => e.Reviews).WithOne(e => e.Goal).HasForeignKey(e => e.GoalId);
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalUpdateRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalUpdateRegistrar.cs
index f14fdda..8b4510c 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalUpdateRegistrar.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/GoalUpdateRegistrar.cs
@@ -19,6 +19,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
                 etb.Property(e => e.Id).ValueGeneratedOnAdd();
                 etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
                 etb.HasOne(e => e.Goal).WithMany(e => e.Updates).HasForeignKey(e => e.GoalId);
+                etb.Property(e => e.CreatedAt).IsRequired();
                 etb.Property(e => e.UpdatedType).IsRequired();
                 etb.Property(e => e.OldValue).IsRequired();
                 etb.Property(e => e.NewValue).IsRequired();
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/ReviewRegistrar.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/ReviewRegistrar.cs
index 5bc000b..e9ac460 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/ReviewRegistrar.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Registrars/ReviewRegistrar.cs
@@ -17,6 +17,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Registrars
             {
                 etb.HasKey(e => e.Id);
                 etb.Property(e => e.Id).ValueGeneratedOnAdd();
+                etb.Property(e => e.CreatedAt).IsRequired();
                 etb.HasOne(e => e.Creator).WithMany().HasForeignKey(e => e.CreatorId);
                 etb.HasOne(e => e.Goal).WithMany(e => e.Reviews).HasForeignKey(e => e.GoalId);
 
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/CommentRepository.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/CommentRepository.cs
index 2143c69..0d3fe34 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/CommentRepository.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/CommentRepository.cs
@@ -56,7 +56,6 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
             Comment item = await dbSet.FindAsync(id);
             if (item == null) return false;
             item.SetText(text);
-            item.IsChanged = true;
             await storageContext.SaveChangesAsync();
             return true;
         }
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GlobalDefinitionAreaRepository.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GlobalDefinitionAreaRepository.cs
new file mode 100644
index 0000000..3d3bf3b
--- /dev/null
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GlobalDefinitionAreaRepository.cs
@@ -0,0 +1,13 @@
+﻿using Leuze.Modules.Goal.Domain.Repositories;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
+{
+    class GlobalDefinitionAreaRepository : IGlobalDefinitionAreaRepository
+    {
+    }
+}
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalDefinitionRepository.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalDefinitionRepository.cs
index c528206..f231796 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalDefinitionRepository.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalDefinitionRepository.cs
@@ -40,7 +40,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
 
         public async Task<List<GoalDefinition>> GetAllForUserAsync(Guid userId)
         {
-            return await dbSet.Include(item => item.Creator).Where(item => item.OwnerId == userId).ToListAsync();
+            return await dbSet.Include(item => item.Creator).Include(item => item.Goals).Include(item => item.GDArea).Where(item => item.OwnerId == userId).ToListAsync();
         }
 
         public async Task<List<GoalDefinition>> GetAllAsync()
@@ -54,29 +54,20 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
             return await dbSet.FindAsync(id);
         }
 
-        public async Task<bool> SetVariAsync(Guid id, decimal vari)
+        public async Task<bool> SetVariProjectHoursAsync(Guid id, double variHours)
         {
             GoalDefinition item = await dbSet.FindAsync(id);
             if (item == null) return false;
-            item.SetVari(vari);
+            item.SetVariProjectHours(variHours);
             await storageContext.SaveChangesAsync();
             return true;
         }
 
-        public async Task<bool> SetFromAsync(Guid id, DateTime from)
+        public async Task<bool> SetFinanceBaseAsync(Guid id, double financeBase)
         {
             GoalDefinition item = await dbSet.FindAsync(id);
             if (item == null) return false;
-            item.SetFrom(from);
-            await storageContext.SaveChangesAsync();
-            return true;
-        }
-
-        public async Task<bool> SetToAsync(Guid id, DateTime to)
-        {
-            GoalDefinition item = await dbSet.FindAsync(id);
-            if (item == null) return false;
-            item.SetTo(to);
+            item.SetFinanceBase(financeBase);
             await storageContext.SaveChangesAsync();
             return true;
         }
diff --git a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalItemRepository.cs b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalItemRepository.cs
index 1b3b3f6..564af7b 100644
--- a/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalItemRepository.cs
+++ b/src/Modules/Goal/Infrastructure/Leuze.Modules.Goal.Infrastructure.Persistence/Repositories/GoalItemRepository.cs
@@ -48,7 +48,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
 
         public async Task<List<GoalItem>> GetAllAsync()
         {
-            return dbSet.ToList(); //TODO: Await??
+            return await dbSet.ToListAsync();
         }
 
         public async Task<bool> SetNameAsync(Guid id, string name)
@@ -69,7 +69,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
             return true;
         }
 
-        public async Task<bool> SetPercentileUserAsync(Guid id, decimal percentile)
+        public async Task<bool> SetPercentileUserAsync(Guid id, double percentile)
         {
             GoalItem item = await dbSet.FindAsync(id);
             if (item == null) return false;
@@ -78,7 +78,7 @@ namespace Leuze.Modules.Goal.Infrastructure.Persistence.Repositories
             return true;
         }
 
-        public async Task<bool> SetPercentileFinalAsync(Guid id, decimal percentile)
+        public async Task<bool> SetPercentileFinalAsync(Guid id, double percentile)
         {
             GoalItem item = await dbSet.FindAsync(id);
             if (item == null) return false;
